#ifndef _Conn_h
#define _Conn_h 1

#include <Conn_engine_core.h>

extern int		Conn_engine_set(const unsigned int engine);
extern int		Conn_init(const unsigned int max);
extern int		Conn_shutdown(void);
extern ssize_t		Conn_send(struct Conn *C, void *buf, const size_t count);
extern ssize_t		Conn_recv(struct Conn *C, void *buf, const size_t count);
extern struct Conn	*Conn_socket_addr(const int domain, const int type,
				const char *addr, const int port);
extern struct Conn	*Conn_socket(const int domain, const int type,
				const int port);
extern int		Conn_set_socket_domain(struct Conn *C, const int domain);
extern int		Conn_set_socket_type(struct Conn *C, const int type);
extern int		Conn_set_socket_protocol(struct Conn *C, const int proto);
extern int		Conn_set_socket_bind_addr(struct Conn *C, const char *addr);
extern int		Conn_set_socket_addr(struct Conn *C, const char *addr);
extern int		Conn_set_socket_bind_port(struct Conn *C, const int port);
extern int		Conn_set_socket_port(struct Conn *C, const int port);
extern int		Conn_poll(const int timeout);
extern int		Conn_enqueue(struct Conn *C, void *buf,
				const size_t count);
extern struct Conn	*Conn_connect(const int domain, const int type,
				const char *addr, const int port);
extern int		Conn_band(struct Conn *C, const unsigned int width,
				const unsigned int factor);
extern struct Conn	*Conn_alloc(void);
extern int		Conn_commit(struct Conn *C);
extern char		*Conn_sys(void);
extern unsigned long long	Conn_lifetime(struct Conn *C);
#endif
